package com.flowing.light.board.fragment

import android.os.Bundle
import android.util.Log
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import androidx.core.view.isVisible
import androidx.fragment.app.Fragment
import androidx.lifecycle.lifecycleScope
import androidx.recyclerview.widget.GridLayoutManager
import com.flowing.light.board.FlowingLightBoard
import com.flowing.light.board.bean.BeanDetails
import com.flowing.light.board.databinding.FragmentFavoriteBinding
import com.flowing.light.board.db.BaseDataBase
import com.flowing.light.board.db.DatabaseManager
import com.flowing.light.board.callback.DeleteFavoriteCallback
import com.flowing.light.board.adapter.FavoriteAdapter
import kotlinx.coroutines.launch

class FragmentFavorite : Fragment() {
    private lateinit var vb: FragmentFavoriteBinding
    companion object {

        @JvmStatic
        fun newInstance() =
            FragmentFavorite()
    }

    override fun onCreateView(
        inflater: LayoutInflater, container: ViewGroup?,
        savedInstanceState: Bundle?
    ): View? {
        vb = FragmentFavoriteBinding.inflate(layoutInflater)

        init()

        return vb.root
    }


    private fun init() {
        val mainAdapter = FavoriteAdapter(
            requireContext()
        ).apply {
            setRemoveLike(object : DeleteFavoriteCallback {
                override fun OnRemoveLike(data: BeanDetails) {
                     lifecycleScope.launch {
                         DatabaseManager.removeLike(data)
                     }
                }

            })
        }
        vb.likeRecycler.run {
            adapter = mainAdapter
            layoutManager = GridLayoutManager(requireContext(), 2)
        }

        BaseDataBase.Companion.baseDataBase.ThemesDao().queryAllLike().observe(requireActivity()) {
            Log.d(FlowingLightBoard.Companion.TAG, "---------it=${it?.size}")
            if(it.isNullOrEmpty()){
                vb.likeRecycler.isVisible = false
                vb.emptyTitle.isVisible = true
            }else{
                vb.likeRecycler.isVisible = true
                vb.emptyTitle.isVisible = false
                mainAdapter.setForYouList(it)
            }

        }
    }


}